---------------------
-- Library calling --
---------------------
--Call the ACE Libraries
local MBPNbattle = LibStub("AceGUI-3.0")
--local AceGUI = LibStub("AceGUI-3.0")
local MBPNCbattle = LibStub("AceConsole-3.0")
LibStub("AceEvent-3.0"):Embed(MBPNCbattle)

-------------------------------------------------------------------------------
----------------------
-- local definitons --
----------------------
MBPNbattleEnable = true
local battleFrame = battleFrame or {}
local battleScrollContainer = {}--battleScrollContainer
local battleScroll = {}--battleScroll
local battleLabel = {}--battleLabel
local battleButton1 = {}--battleButton1
local battleButton2 = {}--battleButton2

-------------------------------------------------------------------------------
-------------------
-- clear filters --
-------------------


function ClearFilters()
   p = C_PetJournal
   p.AddAllPetSourcesFilter(true)
   p.AddAllPetTypesFilter(true)
   p.ClearSearchFilter(true)
   
end


-------------------------------------------------------------------------------
--------------------------------
-- Code for pet battle Window --
--------------------------------
local released = false

function quitBattle(widget)
   p = C_PetBattles
   p.ForfeitGame(true)
   if not MBPNbattle then return end
   if not released then
      battleFrame:Release(widget)
      released = true
   end
end


function MBPNCbattle:PetBattleEnd()
   if not MBPNbattle then return end
   if not battleFrame then return end
   if not released then
      battleFrame:Release(widget)
      released = true
   end
end
function OpenSearchWindow(button)
   MBPNCsearch:MBPNsearchWindow("")
end

function CreateBattleWindow()
   if not MBPNbattleEnable then return end
   released = false
   battleFrame = MBPNbattle:Create("Frame")
   battleScrollContainer = MBPNbattle:Create("SimpleGroup")
   battleScroll = MBPNbattle:Create("ScrollFrame")
   battleButton1 = MBPNbattle:Create("Button")
   battleButton2 = MBPNbattle:Create("Button")
   battleFrame:SetTitle("My Battle Pet Notifier")
   battleFrame:SetStatusText("PetBattle!")
   battleFrame:SetWidth(350)
   battleFrame:SetHeight(400)
   battleFrame:SetPoint("LEFT",nil,"LEFT")
   battleFrame:SetLayout("List")
   battleFrame:SetCallback("OnClick", function() released = true; end)
   --scroll props
   battleScroll:SetLayout("List")
   
   --button1 props
   battleButton1:SetText("Quit Battle")
   battleButton1:SetWidth(150)
   battleButton1:SetCallback("OnClick", function(widget) quitBattle(widget) end)
   
   --button2 props
   battleButton2:SetText("Toggle Search Window")
   battleButton2:SetWidth(200)
   battleButton2:SetCallback("OnClick", function(button) OpenSearchWindow(button) end)
   
   
   
   --scrollcontainer props
   battleScrollContainer:SetFullWidth(true)
   battleScrollContainer:SetWidth(200)
   battleScrollContainer:SetHeight(200)
   battleScrollContainer:SetFullHeight(true)
   battleScrollContainer:SetLayout("Fill")
   battleFrame:AddChild(battleButton2)
   battleFrame:AddChild(battleScrollContainer)
   battleScrollContainer:AddChild(battleScroll)
   battleFrame:AddChild(battleButton1)
end

function MBPNCbattle:PetChanged(event,y)
   if not MBPNbattle then print("Disabled!"); return end
   
   b = C_PetBattles
   if y == 2 then
      local c = b.GetActivePet(y)
      local r = b.GetBreedQuality(y,c)
      local n = b.GetName(y,c)
      local l = b.GetLevel(y,c)
      battleFrame:SetStatusText("("..l..") "..rarityColor[r]..n)
   end
end

function MBPNCbattle:PetBattleStart(event,...) 
   released = false
   if not MBPNbattleEnable then return end
   ClearFilters()
   if C_PetBattles.IsWildBattle(2,i) then
      p = C_PetJournal
      p.ClearSearchFilter(true)
      q = {}
      CreateBattleWindow()
      for i=1,C_PetBattles.GetNumPets(2) do
         c = 0
         petCount = 0
         quality = 0
         lvl = C_PetBattles.GetLevel(2,i)
         o =  C_PetBattles.GetName(2,i)
         local Quality = C_PetBattles.GetBreedQuality(2,i)
         battleLabel = MBPNbattle:Create("InteractiveLabel")
         battleLabel:SetFullWidth(true)
         battleLabel:SetFont("Fonts\\FRIZQT__.TTF",12)
         battleLabel:SetImage(C_PetBattles.GetIcon(2,i))
         battleLabel:SetText("|cFFf9eb77 Wild Pet "..i..":|r "..rarityColor[Quality]..C_PetBattles.GetName(2,i).."|r (L"..lvl..")")
         battleScroll:AddChild(battleLabel)
         
         for j=1, p.GetNumPets(false) do
            id,aa,_,_,level,_,_,n,icon,_,_,d=p.GetPetInfoByIndex(j);
            if id > 0 and n == o then
               c = c + 1;
               battleLabel = MBPNbattle:Create("InteractiveLabel")
               battleLabel:SetFullWidth(true)
               battleLabel:SetFont("Fonts\\FRIZQT__.TTF",12)
               battleLabel:SetImage(icon)
               battleLabel:SetText("You have: "..p.GetBattlePetLink(id).."|r (L"..level..")")
               battleScroll:AddChild(battleLabel)
            end
         end
         if c == 0 then
            battleLabel = MBPNbattle:Create("Label")
            battleLabel:SetFullWidth(true)
            battleLabel:SetFont("Fonts\\FRIZQT__.TTF",12)
            battleLabel:SetText("You have no "..rarityColor[0]..o.."|r!")
            battleScroll:AddChild(battleLabel)
         end
         battleLabel = MBPNbattle:Create("Label")
         battleLabel:SetFullWidth(true)
         battleLabel:SetFont("Fonts\\FRIZQT__.TTF",12)
         battleLabel:SetText(" ")
         battleScroll:AddChild(battleLabel)         
      end
   end
end

------------------------------------------
-- Events and slash command registering --
------------------------------------------

MBPNCbattle:RegisterEvent("PET_BATTLE_OPENING_START","PetBattleStart")
MBPNCbattle:RegisterEvent("PET_BATTLE_CLOSE","PetBattleEnd")
MBPNCbattle:RegisterEvent("PET_BATTLE_PET_CHANGED","PetChanged")