---------------------
-- Library calling --
---------------------
--Call the ACE Libraries
MBPNsearch = LibStub("AceGUI-3.0")
--local AceGUI = LibStub("AceGUI-3.0")
MBPNCsearch = LibStub("AceConsole-3.0")
LibStub("AceEvent-3.0"):Embed(MBPNCsearch)

-------------------------------------------------------------------------------
----------------------
-- local definitons --
----------------------
MBPNframe = MBPNframe
-------------------------------------------------------------------------------
-----------------------
-- tree group select --
-----------------------

local function CreateSearchTab(container)
   
   
   function PetFinder(search)
      
      ClearFilters()
      local x={};
      local text = ""
      local labels = {}
      local count = 1
      local p = C_PetJournal;
      local n = "|n"
      for i=1,p.GetNumPets(false) do 
         local label = MBPNsearch:Create("InteractiveLabel")
         label:SetFullWidth(true)
         id,_,_,_,l,_,_,nm,ic,_,_,d=p.GetPetInfoByIndex(i);
         if string.find(strlower(nm), strlower(search)) and not x[nm] then 
            if id>0 then 
               name, customName, level, xp, maxXp, sourceText, description, health, maxHealth, rarity = GetPetInfoByID(id)
               cName = ""
               if name ~= customName then cName = " ("..customName..")" end
               label:SetText(p.GetBattlePetLink(id)..cName.." (L"..l..")"..n..sourceText..n..d..n..n)
               label:SetImage(ic)
               label:SetImageSize(64,64)
            else 
               label:SetText(nm..n..d..n..n)
               x[nm]=1;
            end 
            labels[count] = label
            count = count + 1
         end 
      end
      return labels
   end
   
   searchScrollGroup = MBPNsearch:Create("ScrollFrame")
   searchGroup = MBPNsearch:Create("SimpleGroup")
   editbox = MBPNsearch:Create("EditBox")
   function EditBoxEnterPressed(_,_,text)
      filter = {
         ["name"] = true,
         ["source"] = false,
         ["description"] = false,
         ["abilityname"] = false,
         ["abilitytext"] = false,
      }
      local search = text
      searchScrollGroup:ReleaseChildren()
      local heading = MBPNsearch:Create("Heading")
      heading:SetFullWidth(true)
      heading:SetText("Searching for '"..text.."'")
      local label1 = MBPNsearch:Create("Label")
      label1:SetText(" ")
      searchScrollGroup:AddChild(heading)
      if not search then search = "" end
      if  strlen(search) < 2 then print("Please use at least 2 characters when searching") return end
      local pets = PetDownloader
      local abilities = {}
      local s = strlower(search) or ""
      for i=1,#pets["index"] do
         local found = false
         local idx = pets["index"][i]
         local name = pets["name"][i] or " "
         if pets[name] then
            --local src = pets["sourcetext"][i] or " "
            --local des = pets["petdesc"][i] or " "
            --local source = strlower(src) or " "
            --local desc = strlower(des) or " "
            local name = strlower(name) or " "
            if string.find(name,s) and filter["name"] then found = true end
            --if string.find(source,s) and filter["source"] then found = true end
            --if string.find(desc,s) and filter["description"] then found = true end         
            --for j=1,6 do
            --local abtext = pets["petabilitytext"][idx][j] or " "
            --local abt = strlower(abtext) or " "
            --local abname = pets["petabilityname"][idx][j] or " "
            --local abn = strlower(abname) or " "
            --if string.find(abt,s) and filter["abilitytext"] then found = true end
            --if string.find(abn,s) and filter["abilityname"] then found = true end
            --end
            if found then
               local level = pets["level"][i]
               local petname = pets["link"][i] or pets["name"][i]
               local levelText = ""
               local link = ""
               if level > 0 then levelText = " (L"..level..") " 
               else
                  levelText = " (Not Owned)"
               end
               
               local searchFindHeader = MBPNsearch:Create("Heading")
               searchFindHeader:SetFullWidth(true)
               searchFindHeader:SetText(petname..levelText)
               local searchFindLabel1 = MBPNsearch:Create("InteractiveLabel")
               searchFindLabel1:SetFullWidth(true)
               searchFindLabel1:SetText(pets["sourcetext"][i])
               searchFindLabel1:SetImage(pets["peticon"][i])
               searchFindLabel1:SetImageSize(48,48)
               local searchFindLabel2 = MBPNsearch:Create("InteractiveLabel")
               searchFindLabel2:SetFullWidth(true)
               searchFindLabel2:SetText(pets["petdesc"][i])
               searchScrollGroup:AddChild(searchFindHeader)
               searchScrollGroup:AddChild(searchFindLabel1)
               searchScrollGroup:AddChild(searchFindLabel2)
               --local inlineGroup = MBPNsearch:Create("InlineGroup")
               --inlineGroup:SetFullWidth(true)
               --inlineGroup:SetTitle("Abilities")
               --for num=1,6 do 
               --   local abilname = pets["petabilityname"][i][num]
               --   local abilframe = pets["petabilityid"][abilname] or {}
               --   if not abilframe then 
               --      MBPNsearch:Create("InteractiveLabel")
               --      abilframe:SetFullWidth(true)
               --      abilframe:SetImage(pets["petabilityicon"][i][num])
               --   else
               --   end 
               --   inlineGroup:AddChild(abilframe)
               --end
               --searchScrollGroup:AddChild(inlineGroup)
            end
         end
      end
   end
   
   searchGroup:SetFullWidth(true)
   searchScrollGroup:SetFullWidth(true)
   --searchGroup:SetFullHeight(true)
   searchScrollGroup:SetFullHeight(true)
   editbox:SetFullWidth(true)
   editbox:SetCallback("OnEnterPressed",EditBoxEnterPressed)
   searchGroup:AddChild(editbox)
   container:AddChild(searchGroup)
   container:AddChild(searchScrollGroup)
end

-------------------------------------------------------------------------------
-----------------------
-- tree group select --
-----------------------

local function TreeGroupHandler(container)
   
   function TreeGroupSelected(group,event,node)
      
      local petLink = petLink
      function ShowContinentInfo(c)
         text = c
         return text
      end
      
      function ShowPetsInZone(z)
         local pets = SearchZoneForPets(z)
         local min, max = GetZoneLevelByName(z)
         local n = "|n"
         local text = ""
         for i=1, # pets do
            pet = pets[i]
            local name = pet["name"]
            local level = pet["level"]
            local customName = pet["customName"]
            local rarity = pet["rarity"]
            if level ~= nil then
               text = text..rarityColor[rarity]..name.."|r (L"..level..")"..n
            end
         end
         return text
      end
      
      function ShowPetTypeInfo(t)
         local text = rarityColor[0].."No pets found in this zone!"
         for i=1,p.GetNumPets(false) do
            local petID, speciesID, isOwned, customName, level, favorite, isRevoked, name, icon, petType, creatureID, sourceText, description, isWildPet, canBattle = p.GetPetInfoByIndex(i)
            if name == t then
               text = ""
               local n = "|n"
               text = text.."Creature Type: "..name..n..n
               text = text.."Source: "..sourceText..n..n
               text = text.."Description: "..description
            end
         end
         return text
      end
      
      function ShowMyPetInfo(m,t)
         local speciesID, customName, level, xp, maxXp, displayID, name, icon, petType, creatureID, sourceText, description, isWild, canBattle,tradable, unique = C_PetJournal.GetPetInfoByPetID(m)
         local health, maxHealth, attack, speed, rarity = p.GetPetStats(m)
         local link = ""
         local text = ""
         local n = "|n"
         if customName ~= nil then
            text = text.."Custom Name: "..customName..n..n
         end
         text = text.."Creature Type: "..t..n..n
         text = text.."Pet ID: "..m..n..n
         text = text.."Level: "..level..n..n
         text = text.."XP: "..xp.."/"..maxXp..n..n
         text = text.."Source: "..sourceText..n..n
         text = text.."Desciption: "..description..n..n
         if tradable then
            text = text.."Tradable: Yes"..n..n
         else
            text = text.."Tradable: No"..n..n
         end
         text = text.."Health: "..health.."/"..maxHealth..n..n
         text = text.."Attack "..attack..n..n
         text = text.."Speed: "..speed..n..n
         r = {
            [0] = rarityColor[0].."Unknown|r",
            [1] = rarityColor[1].."Poor|r",
            [2] = rarityColor[2].."Common|r",
            [3] = rarityColor[3].."Uncommon|r",
            [4] = rarityColor[4].."Rare|r",
            [5] = rarityColor[5].."Epic|r"
         }
         text = text.."Rarity: "..r[rarity]
         return text,name,link,level,icon,speciesID
      end
      function OnIconClick(frame,event,button)
         print(frame,event,button)
         iframe = GetClickFrame(frame)
         iframe:Show()
      end
      
      treeScrollFrame:ReleaseChildren()
      local c, z, t, m = strsplit("\001",node,4)
      local pets={{}}
      local label1 = MBPNsearch:Create("InteractiveLabel")
      local label2 = MBPNsearch:Create("InteractiveLabel")
      local label3 = MBPNsearch:Create("InteractiveLabel")
      local header = MBPNsearch:Create("Heading")
      header:SetText(" ")
      label1:SetText(" ")
      label2:SetText(" ")
      label3:SetText(" ")
      header:SetFullWidth(true)
      label1:SetFullWidth(true)
      label2:SetFullWidth(true)
      label3:SetFullWidth(true)
      local abilityGroup = MBPNsearch:Create("SimpleGroup")
      local min, max
      if z ~= nil then
         pets = SearchZoneForPets(z)
         if pets ~= nil and # pets > 0 then
         end
         min, max = GetZoneLevelByName(z)
      end
      if m ~= nil then
         petID = tonumber(m)
         text, name,link,level, icon, speciesID = ShowMyPetInfo(m,t)
         abilityGroup:SetFullWidth(true)
         abilityGroup:SetFullHeight(true)
         petIndex = PetDownloader[t]
         abilityGroup:ReleaseChildren()
         for abs=1,6 do
            local abil = PetDownloader["petability"][petIndex][abs]
            local aName = PetDownloader["petabilityname"][petIndex][abs]
            local aText = PetDownloader["petabilitytext"][petIndex][abs]
            local aIcon = PetDownloader["petabilityicon"][petIndex][abs]
            local a1 = MBPNsearch:Create("InteractiveLabel")
            a1:SetFullWidth(true)
            a1:SetText(" ")
            a1:SetText(aText)
            a1:SetImage(aIcon)
            a1:SetImageSize(48,48)
            local ah = MBPNsearch:Create("Heading")
            ah:SetFullWidth(true)
            ah:SetText(" ")
            ah:SetText(aName)
            abilityGroup:AddChild(ah)
            abilityGroup:AddChild(a1)
         end         
         name = "(L"..level..") "..name
         label1:SetText(text)
         header:SetText(name)
         ic = MBPNsearch:Create("Icon")
         ic:SetCallback("OnIconClick",OnIconClick)
         petLink = link
         ic:SetImage(icon)
         ic:SetImageSize(72,72)
         treeScrollFrame:AddChild(header)
         treeScrollFrame:AddChild(ic)
         treeScrollFrame:AddChild(label1)
         treeScrollFrame:AddChild(abilityGroup)
         
      elseif t ~= nil then
         petIndex = PetDownloader[t]
         abilityGroup:SetFullWidth(true)
         abilityGroup:SetFullHeight(true)
         abilityGroup:ReleaseChildren()
         for abs=1,6 do
            local abil = PetDownloader["petability"][petIndex][abs]
            local aName = PetDownloader["petabilityname"][petIndex][abs]
            local aText = PetDownloader["petabilitytext"][petIndex][abs]
            local aIcon = PetDownloader["petabilityicon"][petIndex][abs]
            
            local a1 = MBPNsearch:Create("InteractiveLabel")
            a1:SetFullWidth(true)
            a1:SetText(" ")
            a1:SetText(aText)
            a1:SetImage(aIcon)
            a1:SetImageSize(48,48)
            local ah = MBPNsearch:Create("Heading")
            ah:SetFullWidth(true)
            ah:SetText(" ")
            ah:SetText(aName)
            abilityGroup:AddChild(ah)
            abilityGroup:AddChild(a1)
         end         
         
         header:SetText("Pet Type: "..t)
         label2:SetText(ShowPetTypeInfo(t))
         treeScrollFrame:AddChild(header)
         treeScrollFrame:AddChild(label2)
         treeScrollFrame:AddChild(abilityGroup)
      elseif z ~= nil then
         header:SetText("Zone: "..z)
         label3:SetText(ShowPetsInZone(z))
         treeScrollFrame:AddChild(header)
         treeScrollFrame:AddChild(label3)
         treeScrollFrame:AddChild(abilityGroup)
      elseif c ~= nil then
         header:SetText(ShowContinentInfo(c))
         treeScrollFrame:AddChild(header)
      end
   end
   
   local tree = ZoneTree
   treeGroup = MBPNsearch:Create("TreeGroup")
   treeGroup:SetFullWidth(true)
   treeGroup:SetFullHeight(true)
   treeGroup:SetCallback("OnGroupSelected",TreeGroupSelected)
   treeGroup:SetTree(tree)
   treeGroup:SetFullWidth(true)
   treeGroup:SetFullHeight(true)
   treeGroup:EnableButtonTooltips(false)
   treeScrollFrame = MBPNsearch:Create("ScrollFrame")
   treeScrollFrame:SetFullWidth(true)
   treeScrollFrame:SetFullHeight(true)
   treeGroup:AddChild(treeScrollFrame)
   container:AddChild(treeGroup)
   local continentID = GetCurrentMapContinent()
   local continent = GetContinentByID(continentID)
   local zoneID = GetCurrentMapZone()
   local zone = GetZoneByID(continentID,zoneID)
   local defaultTree = continent.."\001"..zone
   treeGroup:SelectByPath(defaultTree)
end

-------------------------------
-- handler for tab selection --
-------------------------------


local function SelectTabGroup(container,event,group)
   container:ReleaseChildren()
   if group=="searchGroup" then
      CreateSearchTab(container)
   end
   if group=="browseGroup" then
      TreeGroupHandler(container)
   end
end

-------------------------------
-- handler for command /pets --
-------------------------------

function MBPNCsearch:MBPNsearchWindow(msg)
   if not msg then msg = "" end
   if not MBPNframe or strlower(msg) == "reset" then
      PetDownloader_Download()
      MBPNframe = MBPNsearch:Create("Window")
      MBPNframe:SetTitle("My Pet Battle Notifier")
      MBPNframe:SetWidth(450)
      MBPNframe:SetHeight(500)
      MBPNframe:SetPoint("RIGHT",nil,"RIGHT")
      MBPNframe:SetLayout("Fill")
      MBPNframe:SetCallback("OnClose",function(widget) MBPNframe:Hide() end)
      
      tabGroup = MBPNsearch:Create("TabGroup")
      tabGroup:SetFullWidth(true)
      tabGroup:SetFullHeight(true)
      tabGroup:SetLayout("Flow")
      tabGroup:SetTabs({
            {text="Browse",value="browseGroup"},
            {text="Search",value="searchGroup"},
            --{text="Journal",value="journalGroup"},
      })
      tabGroup:SetCallback("OnGroupSelected",SelectTabGroup)
      MBPNframe:AddChild(tabGroup)
      tabGroup:SelectTab("browseGroup")
   else
      if MBPNframe:IsVisible() then MBPNframe:Hide()
      else
         PetDownloader_Download()
         MBPNframe:Show()
      end
   end
end
------------------------------------------
-- Events and slash command registering --
------------------------------------------


MBPNCsearch:RegisterChatCommand("pets", "MBPNsearchWindow")
